/**
 * Kairos.js - A non date-based time calculator
 * @author Rodrigo Gomes da Silva <rodrigo.smscom@gmail.com>
 * @version v2.1.1
 * @link https://github.com/kairos
 * @license BSD-2-Clause
 */
!function(){"use strict";var n={};n._pattern="#hh:mm:ss.SSS",n._validator=new RegExp(/^[+-]?\d\d:\d\d:\d\d\.\d\d\d/),n._autoParser=!1;var t,e="object"==typeof self&&self.self===self&&self||"object"==typeof global&&global.global===global&&global||this;null!==e&&(t=e.Kairos),n.noConflict=function(){return e.Kairos=t,n},n.setPattern=function(t){n._validator=n.Lexicon.getValidator(t),n._pattern=t},n.getPattern=function(){return n._pattern},n.setAutoParser=function(t){n._autoParser=!!t},n.getAutoParser=function(){return n._autoParser},n.validate=function(t,e){return n.Lexicon.validate(t,e)},n.new=function(t,e){return new n.Engine(t,e)},n.absolute=function(t,e){return n.new(t,e).toAbsolute()},n.plus=function(t,e,r){return n.new(t,r).plus(e,r)},n.minus=function(t,e,r){return n.new(t,r).minus(e,r)},n.multiply=function(t,e,r){return n.new(t,r).multiply(e)},n.divide=function(t,e,r){return n.new(t,r).divide(e)},n.getFraction=function(t,e,r,o){if(e>r)throw new Error("Improper fraction");return n.new(t,o).multiply(e).divide(r)},n.getInterval=function(t,e,r){return n.new(t,r).minus(e,r).toAbsolute()},n.toMilliseconds=function(t,e){return n.new(t,e).toMilliseconds()},n.toSeconds=function(t,e){return n.new(t,e).toSeconds()},n.toMinutes=function(t,e){return n.new(t,e).toMinutes()},n.toHours=function(t,e){return n.new(t,e).toHours()},n.compare=function(t,e,r){return n.new(t,r).compareTo(e,r)},n.min=function(t,e){t instanceof Array||(e=null,t=Array.prototype.slice.call(arguments));var r=t.reduce(function(t,r){return n.compare(t,r,e)<0?t:r});return n.new(r,e)},n.max=function(t,e){t instanceof Array||(e=null,t=Array.prototype.slice.call(arguments));var r=t.reduce(function(t,r){return n.compare(t,r,e)>0?t:r});return n.new(r,e)},"object"==typeof module&&module.exports?module.exports=n:"function"==typeof define&&define.amd?define([],function(){return n}):e.Kairos=n,Math.trunc=Math.trunc||function(n){return n<0?Math.ceil(n):Math.floor(n)}}();
!function(){"use strict";var e={SIGN:"#",HOURS:"h",MINUTES:"m",SECONDS:"s",MILLISECONDS:"S",ESCAPE:"\\"};Kairos.Lexicon={},Kairos.Lexicon.getValidator=function(a){if("string"!=typeof a&&(a=Kairos._pattern),a===Kairos._pattern)return Kairos._validator;for(var t="",r=0,s=a.length;s>r;r++){var i=a[r];switch(i){case e.SIGN:t+="^[+-]?";break;case e.HOURS:case e.MINUTES:case e.SECONDS:case e.MILLISECONDS:t+="\\d";break;default:t+=i.replace(/[-[\]{}()*+?.,\\^$|#\s]/g,"\\$&")}}return new RegExp(t)},Kairos.Lexicon.validate=function(e,a){return Kairos.Lexicon.getValidator(a).test(e)},Kairos.Lexicon.parse=function(a,t){if(t||(t=Kairos._pattern),!Kairos.Lexicon.validate(a,t))throw new Error("Cannot parse expression. Time format doesn't match the current time pattern.");for(var r=!0,s="",i="",n="",c="",o=0,S=t.length;S>o;o++){switch(t[o]){case e.SIGN:-1!==["+","-"].indexOf(a[o])?r="+"===a[o]:(t=t.slice(0,o)+t.slice(o+1),S--,o--);break;case e.HOURS:s+=a[o];break;case e.MINUTES:i+=a[o];break;case e.SECONDS:n+=a[o];break;case e.MILLISECONDS:c+=a[o]}}var l=Kairos.new().addHours(s?+s:0).addMinutes(i?+i:0).addSeconds(n?+n:0).addMilliseconds(c?+c:0);return r||(l.milliseconds=-l.milliseconds),l},Kairos.Lexicon.format=function(a,t,r){t||(t=Kairos._pattern);for(var s=a.milliseconds>=0,i=String(Math.abs(a.getHours())),n=String(Math.abs(a.getMinutes())),c=String(Math.abs(a.getSeconds())),o=String(Math.abs(a.getMilliseconds())),S="",l=(t.match(/\\h/g)||[]).length,h=(t.match(/h/g)||[]).length-l,g=0,d=t.length-1;d>=0;d--){var f=t[d],N=t[d-1]===e.ESCAPE;if(N)S=f+S,d--;else switch(f){case e.SIGN:S=(s?"+":"-")+S;break;case e.HOURS:g++;if(g===h&&i.length>1&&r){S=i+S,r=!1;break}S=(i.slice(-1)||"0")+S,i.length>0&&(i=i.slice(0,i.length-1));break;case e.MINUTES:S=(n.slice(-1)||"0")+S,n.length>0&&(n=n.slice(0,n.length-1));break;case e.SECONDS:S=(c.slice(-1)||"0")+S,c.length>0&&(c=c.slice(0,c.length-1));break;case e.MILLISECONDS:S=(o.slice(-1)||"0")+S,o.length>0&&(o=o.slice(0,o.length-1));break;default:N||(S=f+S)}}return S},Kairos.Lexicon.findPattern=function(a){for(var t="",r=e.HOURS,s=0,i=a.length;i>s;s++){var n=a[s];if(-1===["+","-"].indexOf(n))if(isNaN(n)){if(isNaN(n))switch(t+=n,r){case e.HOURS:r=e.MINUTES;break;case e.MINUTES:r=e.SECONDS;break;case e.SECONDS:r=e.MILLISECONDS;break;default:r=!1}}else t+=r||n;else t+=e.SIGN}return t}}();
!function(){"use strict";var i={SECOND:1e3,MINUTE:6e4,HOUR:36e5};Kairos.Engine=function(i,t){if(i){if(i instanceof Kairos.Engine)return i;if("number"==typeof i)return this.milliseconds=i,this;if("string"==typeof i&&i.length>0)return Kairos.getAutoParser()&&(t=Kairos.Lexicon.findPattern(i)),new Kairos.Lexicon.parse(i,t);throw new Error("Invalid arguments")}},Kairos.Engine.prototype._resolveStep=function(t,n){switch(t){case 1:this.removeMilliseconds(this.getMilliseconds());break;case i.SECOND:this.removeSeconds(this.getSeconds());break;case i.MINUTE:this.removeMinutes(this.getMinutes());break;case i.HOUR:this.removeHours(this.getHours())}return this.milliseconds+n*t},Kairos.Engine.prototype.milliseconds=0,Kairos.Engine.prototype.setHours=function(t){return this.milliseconds=this._resolveStep(i.HOUR,t),this},Kairos.Engine.prototype.getHours=function(){return Math.trunc(this.milliseconds/i.HOUR)},Kairos.Engine.prototype.setMinutes=function(t){return this.milliseconds=this._resolveStep(i.MINUTE,t),this},Kairos.Engine.prototype.getMinutes=function(){return Math.trunc(Math.trunc(this.milliseconds-Math.trunc(this.toHours())*i.HOUR)/i.MINUTE)},Kairos.Engine.prototype.setSeconds=function(t){return this.milliseconds=this._resolveStep(i.SECOND,t),this},Kairos.Engine.prototype.getSeconds=function(){return Math.trunc(Math.trunc(this.milliseconds-Math.trunc(this.toMinutes())*i.MINUTE)/i.SECOND)},Kairos.Engine.prototype.setMilliseconds=function(i){return this.milliseconds=this._resolveStep(1,i),this},Kairos.Engine.prototype.getMilliseconds=function(){return Math.trunc(this.milliseconds-Math.trunc(this.toSeconds())*i.SECOND)},Kairos.Engine.prototype.addHours=function(t){return this.milliseconds+=i.HOUR*t,this},Kairos.Engine.prototype.addMinutes=function(t){return this.milliseconds+=i.MINUTE*t,this},Kairos.Engine.prototype.addSeconds=function(t){return this.milliseconds+=i.SECOND*t,this},Kairos.Engine.prototype.addMilliseconds=function(i){return this.milliseconds+=i,this},Kairos.Engine.prototype.removeHours=function(t){return this.milliseconds-=i.HOUR*t,this},Kairos.Engine.prototype.removeMinutes=function(t){return this.milliseconds-=i.MINUTE*t,this},Kairos.Engine.prototype.removeSeconds=function(t){return this.milliseconds-=i.SECOND*t,this},Kairos.Engine.prototype.removeMilliseconds=function(i){return this.milliseconds-=i,this},Kairos.Engine.prototype.toHours=function(){return this.milliseconds/i.HOUR},Kairos.Engine.prototype.toMinutes=function(){return this.milliseconds/i.MINUTE},Kairos.Engine.prototype.toSeconds=function(){return this.milliseconds/i.SECOND},Kairos.Engine.prototype.toMilliseconds=function(){return this.milliseconds},Kairos.Engine.prototype.toAbsolute=function(){return this.milliseconds=Math.abs(this.milliseconds),this},Kairos.Engine.prototype.plus=function(i,t){return i=new Kairos.Engine(i,t),this.milliseconds+=i.toMilliseconds(),this},Kairos.Engine.prototype.minus=function(i,t){return i=new Kairos.Engine(i,t),this.milliseconds-=i.toMilliseconds(),this},Kairos.Engine.prototype.multiply=function(i){return this.milliseconds*=i,this},Kairos.Engine.prototype.divide=function(i){return this.milliseconds/=i,this},Kairos.Engine.prototype.compareTo=function(i,t){return i=new Kairos.Engine(i,t),this.milliseconds<i.toMilliseconds()?-1:this.milliseconds===i.toMilliseconds()?0:this.milliseconds>i.toMilliseconds()?1:void 0},Kairos.Engine.prototype.toString=function(i,t){return"boolean"==typeof i&&(t=i,i=null),Kairos.Lexicon.format(this,i,t)}}();